unit preprocessexecutable;
interface
uses classes,sysutils,Preprocesssubstitute,lowx,strutils,preprocesswebcomponents;
const 
 NO_DEBUG = False;
function produceExecutableStatement(data:String;insertdegubcode:boolean):String;

implementation

function produceExecutableStatement(data:String;insertdegubcode:boolean):String;
var cleandata,wcexec,outhold,thisline:String; 
    wclist,unneeded,cleanlist :tstringlist; 
    i:integer; iscontent,etag:boolean;
begin
 {
 accepts a code segment from psp inside
 the main execute of a component OR a method
 removes EVENTS and VARS, 
 builds the calls to use WEBCOMPONENTS
 processes tags into Outputstream.Write
 DOES NOT include begin..end statements
 Basically you get the raw executable code to insert into 
 a function wrapper or whatever
 }
  
 cleandata:=CleanPSPExecutableStatement(data);
 
 {
****************************
  so now we have our code and content on nice separated short lines.
  each begin and end tag is also on its own line, so we can test
  whether we are inside a tag or not!
****************************
 }

 {we need to remove VAR and EVENT Tags... those are processed elsewhere}
 unneeded:=tstringlist.create;
 {yank those VARS}
 //writeln('Vars');
 unneeded:=GetTagList (cleandata,'VAR');
 //writeln('Vars Ready');
 if unneeded.count>0 then
 for i:= 0 to unneeded.count-1 do
   begin
    cleandata:=Replacestring(cleandata,unneeded[i],'');
   end;
 unneeded.clear;
 
 {yank those EVENTS}
//writeln('Events');
 unneeded:=GetTermTagList (cleandata,'EVENT');
 if unneeded.count>0 then
 for i:= 0 to unneeded.count-1 do
   begin
    cleandata:=Replacestring(cleandata,unneeded[i],'');
   end;
 unneeded.clear;
 {cleanup our list}
 unneeded.free;
//writeln('Methods');
  {yank those METHODS}
 unneeded:=GetTagList (cleandata,'METHOD');
 if unneeded.count>0 then
 for i:= 0 to unneeded.count-1 do
   begin
    cleandata:=Replacestring(cleandata,unneeded[i],'');
   end;
 unneeded.clear;
 {cleanup our list}
 unneeded.free;
//writeln('types');
 {yank types and CONSTS}
 unneeded:=GetTagList (cleandata,'TYPE');
 if unneeded.count>0 then
 for i:= 0 to unneeded.count-1 do
   begin
    cleandata:=Replacestring(cleandata,unneeded[i],'');
   end;
 unneeded.clear;
 {cleanup our list}
 unneeded.free;
//writeln('Consts');
  {yank types and CONSTS}
 unneeded:=GetTagList (cleandata,'CONST');
 if unneeded.count>0 then
 for i:= 0 to unneeded.count-1 do
   begin
    cleandata:=Replacestring(cleandata,unneeded[i],'');
   end;
 unneeded.clear;
 {cleanup our list}
 unneeded.free;

{
****************************
ok.. so all we have is content, code, and webcomponents
****************************
}

 {we need to parse out webcomponents onto their own lines} 
//Writeln ('Removed tags');
 wclist:=tstringlist.create;
 wclist:=GetTermTagList (cleandata,'WEBCOMPONENT');
 for i:= 0 to wclist.count-1 do
   begin
    cleandata:=Replacestring(cleandata,wclist[i],#13+#10+wclist[i]+#13+#10);
   end;
 {I won't free it yet since we still need the wclist info for later} 

 {
  now put the execution of a given component into our segment
  EX: 
  <% 
  [componentname].execute; 
  %>
  I just call execute, becuase in the new model the component is going to
  write to Outputstream anyway, and I can just use that instead of bothering
  with two or three extra lines of code;
 }
 for i:= 0 to wclist.count-1 do
   begin
    wcexec := produceWebComponentExecutionStatement (wclist[i]);
    cleandata:=Replacestring(cleandata,wclist[i],wcexec);
   end;

wcexec:='';  

{
****************************
ok.. so all we have is content, and code
****************************
}

{
 now, we need to parse through everything, and if content then 
 put in the Outputstream.write statement, if code then just copy,
if insertdebug then we will use a call: 
 TOnDebug = procedure (sender:tobject;linenum:longint;linetext:String; var Terminate:boolean) of object;
 and a class parameter = Terminate:boolean;
and make this insertion here 


 if assigned(fOnDebug) then fOnDebug (self,[linenum],[linetext],Terminate);
 if Terminate then exit;

 Just remember to include a class parameter called Terminate and the proc def in Webstreamables!

I am ignoring the debug until version 1, if I can decide it is necessary.
}

{populate our list}
iscontent:=true;
etag:=false; {is it a <% or %> ???}
cleanlist:=tstringlist.create;
cleanlist.text:=cleandata;
 
//Writeln ('Pretty much ready to go....');

for i:= 0 to cleanlist.count-1 do
  begin
   thisline:=cleanlist[i];
   etag:=false;
   if (trim(thisline)='<%') OR (trim(thisline)='%>') then etag:= true;
   if trim(thisline)='<%' then iscontent:=false;
   if trim(thisline)='%>' then iscontent:=true;
   if ((iscontent) AND NOT(etag)) then
         begin
	 {
           I don't want to send blank lines, since the result would be
		Outputstream.write ('') anyway
		why clutter our code!
         }
          if trim(thisline) <> '' then outhold:=outhold+ ' Outputstream.write('''+thisline+''');'+#13+#10;
 	{insert debug code here}
	 end;
   if (not(iscontent) AND NOT(etag)) then
         begin
 	{
	I am also ignoring blank lines here, since there isn't really any point
 	}
           if trim(thisline) <> '' then outhold:=outhold+ thisline +#13+#10;
 	{insert debug code here}
	 end;

  end;
{
****************************
outhold contains nothing but executable code.. all content and components have been
converted to code.. so we can just output it and enjoy the results.
****************************
}
result:=outhold;
end;


end. 